'use common library
ExecuteGlobal CreateObject("Scripting.FileSystemObject").OpenTextFile( left( WScript.ScriptFullName , len (WScript.ScriptFullName) -len( WScript.ScriptName ) ) & "vb-script-library.vbs",1).ReadAll()
InitScript("CAPICOM Installer")

sub install_capicom()
    const dllfile = "capicom.dll"
    
    'create shell and filesystem objects
    dlldest = wso.ExpandEnvironmentStrings("%windir%") & "\System32\" & dllfile
    dllsrce  = "CAPICOM\" & dllfile

    'if the library file is not there, copy and register it
    if not fso.FileExists(dlldest) then
        log "   - Copying CAPICOM library"
        fso.CopyFile dllsrce,dlldest,true
    end if        
    
    log "   - Registering CAPICOM library"
    wso.Run "regsvr32 /s " & dlldest ,1,true
end sub

' test for CAPICOM library.
sub VerifyCAPICOM()
dim store
    on error resume next
    set store = CreateObject("Capicom.Store")
    if err.number <> 0 then
        log "The CAPICOM Cryptographic library is not installed. It will be installed."
        install_capicom()
        err.clear
        
        set store = CreateObject("Capicom.Store")
        if err.number <> 0 then
            logerror "It would appear that the CAPICOM library failed to install." 
            finished 
        end if
    end if

    store.Open CAPICOM_LOCAL_MACHINE_STORE,"Root", CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED OR CAPICOM_STORE_OPEN_EXISTING_ONLY
    if err.number <> 0 then
        logerror "CAPICOM is not functioning, and you may need to manually install the library." 
        logerror "Consult the Instructions document." 
        finished 
    end if
    store.Close 
end sub

VerifyCAPICOM
finished